'use strict';

var stripAnsi = require('strip-ansi');
var path = require('path');
var cliSpinner = require('cli-spinners').dots10;

var removeVariance = function removeVariance(input) {
  if (input && input.message) {
    input.message = removeVariance(input.message);
  }
  if ('' + input !== input) {
    for (var k in input) {
      input[k] = removeVariance(input[k]);
    }
    return input;
  }

  var map = {
    SCROLEX_ROOT: path.resolve(path.join(__dirname, '..')),
    PWD: process.cwd(),
    HOME: process.env.HOME,
    USER: process.env.USER
  };

  for (var key in map) {
    var val = map[key];
    while (input.indexOf(val) !== -1) {
      input = input.replace(val, '#{' + key + '}');
    }
  }

  input = stripAnsi(input);

  input = input.replace(/^.*Fetching package.*\n/g, '');
  input = input.replace(/yarn install v\d+\.\d+\.\d+/g, 'yarn install vX.X.X');
  input = input.replace(/Done in \d+\.\d+s/g, 'Done in X.Xs');
  input = input.replace(/^.*peer dependency "es6-promise.*\n/gm, '');
  input = input.replace(/^.*fsevents.*Excluding it from installation.*\n/gm, '');
  input = input.replace(/^.*fsevents.*incompatible with this module.*\n/gm, '');

  // @todo: Remove this hack when scrolex no longer adds trailing spinner frames:
  cliSpinner.frames.forEach(function (frame) {
    while (input.indexOf(frame) !== -1) {
      // console.log({input, frame})
      input = input.replace(frame, '---spinnerframe---');
    }
  });

  return input;
};

module.exports = removeVariance;
//# sourceMappingURL=removeVariance.js.map